//Package 

package onKeyHitEvent
{
	//fxDTSBrick Methods

	function fxDTSBrick::keyCheck(%obj,%accessType,%blidList,%client)
	{
		switch(%accessType)
		{
			case 0:
				%obj.keyCheckUnrestricted(%client);
			case 1:
				%obj.keyCheckAdmin(%client);
			case 2:
				%obj.keyCheckBLIDAllow(%blidList,%client);
			case 3:
				%obj.keyCheckBLIDDeny(%blidList,%client);
			case 4:
				%obj.keyCheckMinigame(%client);
			case 5:
				%obj.keyCheckTrustLevel1(%client);
			case 6:
				%obj.keyCheckTrustLevel2(%client);
		}	
	}

	function fxDTSBrick::keyCheckUnrestricted(%obj,%client)
	{
		%obj.onKeySuccess(%client);
	}
	
	function fxDTSBrick::keyCheckAdmin(%obj,%client)
	{                  	
		if(%client.isAdmin == 1 || %client.isSuperAdmin == 1)
		{
			%obj.onKeySuccess(%client);
			echo(keyCheckAdmin);
		}
		else
		{
			%obj.onKeyFailure(%client);
		}
	}

	function fxDTSBrick::keyCheckBLIDAllow(%obj,%blidList,%client)
	{
		if(%blidList !$= "")
		{
			%ids = 0;

			for(%i = 0;%i < getWordCount(%blidList);%i++)
			{
				%word = getWord(%blidList,%i);
				%fail = 0;

				for(%j = 0;%j < strlen(%word);%j++)
				{
					%char = getSubStr(%word,%j,1);

					if(strstr("1234567890",%char) == -1)
					{
						%fail = 1;
					}
				}

				if(!%fail)
				{
					%id[%ids++] = %word;
				}
			}

			%allow = 0;

			for(%i = 1;%i <= %ids;%i++)
			{
				%blid = %id[%i];

				if(%blid == %client.BL_ID)
				{
					%allow = 1;
					break;
				}
			}

			if(%allow == 1)
			{
				%obj.onKeySuccess(%client);
			}
			else
			{
				%obj.onKeyFailure(%client);
			}
		}
		else
		{
			%obj.onKeyFailure(%client);
		}
	}

	function fxDTSBrick::keyCheckBLIDDeny(%obj,%blidList,%client)
	{
		if(%blidList !$= "")
		{
			%ids = 0;

			for(%i = 0;%i < getWordCount(%blidList);%i++)
			{
				%word = getWord(%blidList,%i);
				%fail = 0;

				for(%j = 0;%j < strlen(%word);%j++)
				{
					%char = getSubStr(%word,%j,1);

					if(strstr("1234567890",%char) == -1)
					{
						%fail = 1;
					}
				}

				if(!%fail)
				{
					%id[%ids++] = %word;
				}
			}

			%deny = 0;

			for(%i = 1;%i <= %ids;%i++)
			{
				%blid = %id[%i];

				if(%blid == %client.BL_ID)
				{
					%deny = 1;
					break;
				}
			}

			if(%deny == 0)
			{
				%obj.onKeySuccess(%client);
			}
			else
			{
				%obj.onKeyFailure(%client);
			}
		}
		else
		{
			%obj.onKeySuccess(%client);
		}
	}

	function fxDTSBrick::keyCheckMinigame(%obj,%client)
	{
		if(miniGameCanUse(%client,%obj) == 1)
		{
			%obj.onKeySuccess(%client);
		}
		else
		{
			%obj.onKeyFailure(%client);
		}
	}

	function fxDTSBrick::keyCheckTrustLevel1(%obj,%client)
	{
		if(getTrustLevel(%client,%obj) >= 1)
		{
			%obj.onKeySuccess(%client);
		}
		else
		{
			%obj.onKeyFailure(%client);
		}
	}

	function fxDTSBrick::keyCheckTrustLevel2(%obj,%client)
	{
		if(getTrustLevel(%client,%obj) >= 2)
		{
			%obj.onKeySuccess(%client);
		}
		else
		{
			%obj.onKeyFailure(%client);
		}
	}

	function fxDTSBrick::onKeyHit(%this, %client)
	{
		$inputTarget_self = %this;
		$inputTarget_client = %client;
		$inputTarget_player = %client.player;
		$inputTarget_miniGame = getMiniGameFromObject(%this);
		%this.processInputEvent("onKeyHit", %client);
	}

	function fxDTSBrick::onKeySuccess(%this, %client)
	{
		$inputTarget_self = %this;
		$inputTarget_client = %client;
		$inputTarget_player = %client.player;
		$inputTarget_miniGame = getMiniGameFromObject(%this);
		%this.processInputEvent("onKeySuccess", %client);
	}

	function fxDTSBrick::onKeyFailure(%this, %client)
	{
		$inputTarget_self = %this;
		$inputTarget_client = %client;
		$inputTarget_player = %client.player;
		$inputTarget_miniGame = getMiniGameFromObject(%this);
		%this.processInputEvent("onKeyFailure", %client);
	}

	//keyProjectile Methods

	function keyProjectile::OnCollision(%this,%obj,%col,%fade,%pos,%normal)
	{
		if(%col.getClassName() $= "fxDtsBrick")
		{
			%col.onKeyHit(%obj.sourceObject.client);
		}
	}
};

ActivatePackage(onKeyHitEvent);

//Input Events

registerInputEvent("fxDTSBrick","OnKeySuccess","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame",1);
registerInputEvent("fxDTSBrick","OnKeyFailure","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame",1);
registerInputEvent("fxDTSBrick","OnKeyHit","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame",1);

//Output Events

registerOutputEvent("fxDTSBrick","keyCheck","list Unrestricted 0 Admin 1 BLIDAllow 2 BLIDDeny 3 Mini-Game 4 TrustLevel1 5 TrustLevel2 6" TAB "string 200 72",1);